﻿using System;

//public struct StructTest
//{
//    int key;
//    public int Key { get { return key; } set { key = value; } }
//}

class Program
{
    int key;
    public int Key { get { return key; } set { key = value; } }

    static void Main(string[] args)
    {
        Program p1 = new Program { Key = 5 };
        Program p2 = new Program { Key = 5 };

        Console.WriteLine("p1 == p2: " + (p1 == p2));
        Console.WriteLine("p1.Equals(p2): " + p1.Equals(p2));
        Console.WriteLine("object.ReferenceEquals(p1, p2): " + object.ReferenceEquals(p1, p2));

        Program p3 = p1;

        Console.WriteLine("p1 == p3: " + (p1 == p3));
        Console.WriteLine("p1.Equals(p3): " + p1.Equals(p3));
        Console.WriteLine("object.ReferenceEquals(p1, p3): " + object.ReferenceEquals(p1, p3));

        //StructTest t1 = new StructTest { Key = 5 };
        //StructTest t2 = new StructTest { Key = 5 };


        //// Operator '==' cannot be applied to operands of type 'StructTest' and 'StructTest'
        ////Console.WriteLine(t1 == t2);
        //Console.WriteLine("t1.Equals(t2): " + t1.Equals(t2));
        //Console.WriteLine("object.ReferenceEquals(t1, t2): " + object.ReferenceEquals(t1, t2));

        //StructTest t3 = t1;

        //// Console.WriteLine(t1 == t3);
        //Console.WriteLine("t1.Equals(t3): " + t1.Equals(t3));
        //Console.WriteLine("object.ReferenceEquals(t1, t3): " + object.ReferenceEquals(t1, t3));
    }

    public override int GetHashCode()
    {
        return key;
    }

    public override bool Equals(object obj)
    {
        Program p = obj as Program;

        if ((object)p == null)
        {
            return false;
        }

        return p.key == key;
    }

    public static bool operator ==(Program objA, Program objB)
    {
        if (System.Object.ReferenceEquals(objA, objB))
        {
            return true;
        }

        if (((object)objA == null) || ((object)objB == null))
        {
            return false;
        }

        return objA.Equals(objB);
    }

    public static bool operator !=(Program objA, Program objB)
    {
        return !(objA == objB);
    }
}
